// panelDlg.cpp : implementation file
//

#include "stdafx.h"
#include "panel.h"
#include "panelDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "PCI1230.h"
#include ".\paneldlg.h"

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

	// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPanelDlg dialog

CPanelDlg::CPanelDlg(CWnd* pParent /*=NULL*/)
: CDialog(CPanelDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPanelDlg)
	// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	int i;
	m_nCardCount = 0;
	m_nCurrCardNo = 0;
	for(i = 0;i < MAX_CARD; i ++)
	{
		m_nCardId[i] = 0;
		m_nDout[i] = 0;
	}
}

void CPanelDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPanelDlg)
	// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_COMBO1, m_CardID);
}

BEGIN_MESSAGE_MAP(CPanelDlg, CDialog)
	//{{AFX_MSG_MAP(CPanelDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	//	ON_CBN_EDITCHANGE(IDC_COMBO1, OnEditchangeCombo1)
	//}}AFX_MSG_MAP
	//	ON_CBN_DBLCLK(IDC_COMBO1, OnCbnDblclkCombo1)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnCbnSelchangeCombo1)
	ON_WM_CLOSE()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPanelDlg message handlers

BOOL CPanelDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	// open card
	int i ;
	unsigned int nRet;
	CString strTemp;

	m_nCardCount = 0;
	// initial card id array
	for(i = 0; i< MAX_CARD; i++)
	{
		m_nCardId[i] = 0;
	}
	for(i=15; i>=0; i--)
	{
		nRet = Pci1230Open(i);
		if(nRet == PCI1230Success)
		{
			// find card
			strTemp.Format(TEXT("%d"),i);
			m_CardID.AddString(strTemp);

			m_nCardId[m_nCardCount] = i;
			m_nCardCount ++;
		}
	}

	if(m_nCardCount == 0)
	{
		AfxMessageBox(TEXT("򿪿ƿʧ"));
		OnOK();
		return FALSE;
	}

	m_CardID.SetCurSel(0);
	m_nCurrCardNo = m_nCardId[0];

	SetTimer(0, 100, NULL);
	return TRUE;
}

void CPanelDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPanelDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPanelDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPanelDlg::OnTimer(UINT nIDEvent)
{
	// TODO: Add your message handler code here and/or call default

	CDialog::OnTimer(nIDEvent);
	UpdateData(TRUE);

	unsigned int  d = 0;
	int i = 0;
	for(i = 0; i < 32; i++)
	{
		// if check is checked ,data shift logic or 1
		if(((CButton *)GetDlgItem(IDC_CHECK1 + i ))->GetCheck())
		{
			d |= (0x01 << i );
		}
	}

	m_nDout[m_nCurrCardNo] = d;
	// write data to pci1230
	Pci1230Write(m_nCurrCardNo, d);

	// read di data
	d = 0;
	Pci1230Read(m_nCurrCardNo, &d);
	for(i = 0; i < 32; i++)
	{
		if( (d & (0x01 << i) ) != 0 )
		{
			((CButton *)GetDlgItem(IDC_CHECK33+i))->SetCheck(TRUE);
		}
		else
		{
			((CButton *)GetDlgItem(IDC_CHECK33+i))->SetCheck(FALSE);
		}
	}

	((CButton *)GetDlgItem(IDC_CHECK_DIO_ON))->SetCheck(TRUE);
	((CButton *)GetDlgItem(IDC_CHECK_DIO_OFF))->SetCheck(FALSE);
}

void CPanelDlg::OnCbnSelchangeCombo1()
{
	// TODO: ڴӿؼ֪ͨ

	CString srtGID;
	unsigned int d = 0;
	int i;

	i = m_CardID.GetCurSel();
	if(i < 0)
		return;

	m_nCurrCardNo = m_nCardId[i];
	d = m_nDout[m_nCurrCardNo];

	for(i = 0; i < 32; i++)
	{
		if( (d & (0x01 << i )) != 0 )
		{
			((CButton *)GetDlgItem(IDC_CHECK1+i))->SetCheck(TRUE);
		}
		else
		{
			((CButton *)GetDlgItem(IDC_CHECK1+i))->SetCheck(FALSE);
		}
	}
	UpdateData(FALSE);
}

void CPanelDlg::OnClose()
{
	// TODO: ڴϢ/Ĭֵ
	unsigned int i = 0;

	KillTimer(0);

	for(i = 0; i < m_nCardCount; i ++)
	{
		Pci1230Close(i);
	}

	CDialog::OnClose();
}
